<?php
header('Content-type: text/html; charset=UTF-8');
require("zoom_defines.php");

$CurrentConfig = $EngineExeDir . "/default.zcfg";
if(isset($_GET["config"]))
{
	$CurrentConfig = $_GET["config"];
}

?>

<html>
	<head>
		<style type="text/css">
			
		#main_content 
		{
			min-width: 1200px;
			margin: 10 auto;
			text-align: left;

		} 	
		
		#status 
		{
			min-width: 700px;
			height: 315px;
			text-align: left;
			float: left;
			overflow : auto;
		} 
		
		#errors_div 
		{
			padding-left: 10px;
			min-width: 400px;
			height: 315px;
			text-align: left;
			float: left;
		}
			
		#thread_status 
		{
			padding-top: 10px;
			min-width: 1100px;
			text-align: left;
		} 
		
		.table_name
		{
			text-align: center;
			font-weight: bold;
		}
		
		.table_header
		{
			text-align: left;
			font-weight: bold;
		}
		
		.thread_table, .error_table
		{
			width: 85%
		}
		
		.status_col
		{
			width: 45%;
			text-align: left;
			font-weight: bold;
		}
		.counter_col
		{
			width: 55%;
			text-align: left;
			font-weight: bold;
		}
		
		.err_status_col
		{
			width: 40%;
			text-align: left;
			font-weight: bold;
		}
		.err_counter_col
		{
			width: 40%;
			text-align: left;
			font-weight: bold;
		}
		
		.err_show_col
		{
			width: 20%;
			text-align: left;
			font-weight: bold;
		}
		
		
		.thread_id_col, .thread_status_col, .thread_prog_col
		{
			width: 10%;
		}
		
		.thread_url_col
		{
			width: 70%;
		}

		</style>
		
		<script>
			
			var isPaused = false;
			var refresh = 0;
			var sendReqTimer = 0;

			function InitButtons()
			{
				document.getElementById("pause").disabled =  true;
				document.getElementById("start").disabled = false;
				document.getElementById("stop").disabled = false;
			}
				
				//set a timeout so status is updated evvery second
				//window.document.onload
				window.onload = InitButtons();


				function SendHttpRequest(param, synchronous)
				{
					
					//Set shared status to command value
					if(window.XMLHttpRequest)
					{
				 		//IE7_, FireFox, Chrome, OPera, Safari
				 		xmlhttp = new XMLHttpRequest();
				 	}
				 	else
				 	{
				  		//IE 6, 5
				  		xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
				 	}					
				 	//Try synchrosous repsonse to get possible error message
					xmlhttp.open("GET", param, synchronous); //true
				 	xmlhttp.send();				 
				 	
				 	if(synchronous == false)
				 	{
				 		var response = xmlhttp.responseText;
				 		if(response.indexOf("Error") != -1)
				 		{
				 			alert(response);
				 			return false;
				 		}
					}
					return true;
				}


				function launchEngine()
				{
					
					//Wait for a synchronous response from the launch command to read any error messages
					var config = document.getElementById("config_filename").value; 
					
					if(config.length < 1)
					{
						alert("No configuration file is selected, please enter a valid configuration file path");
						return false;
					}
					return SendHttpRequest("launch_engine.php?config=" + config, false);
				}
				
				function SendStartCommand()
				{
					SendHttpRequest("send_zoom_command.php?command="+<?PHP echo $__CUSTOM_BUILD_ZOOM_CMD_START; ?>, true);
					//clearTimeout(sendReqTimer);
					pageTimeout();
				}
				
				
				//Call the send command php module to send a command to the indexer
				//Disable/enable buttons as appropriate
				function sendCommand(buttonID)
				{					
					var zoomCmd;
					
					if(buttonID == "start")
					{
						//Disable start
							document.getElementById("start").disabled = true;

						//Need to launch engine if not already running or just seed sartt/unpause command if running and in paused state
						if(isPaused == false)
						{
								
							if(launchEngine() == true)
							{
								//Enable pause and stop
								document.getElementById("pause").disabled = false;
								document.getElementById("stop").disabled = false;
							
								//sendReqTimer = setTimeout(SendStartCommand, 1000, true);	
								SendStartCommand();
	
							}	
							else
							{
								//Enable start
								document.getElementById("start").disabled = false;
							}		
						}
						else
						{
							//Enable pause and stop
							document.getElementById("pause").disabled = false;
							document.getElementById("stop").disabled = false;
							
								
							zoomCmd = <?PHP echo $__CUSTOM_BUILD_ZOOM_CMD_RESUME; ?>;
							SendHttpRequest("send_zoom_command.php?command="+zoomCmd);
							pageTimeout();
						}		
						return;
					}
					else if(buttonID == "pause")
					{
						zoomCmd = <?PHP echo $__CUSTOM_BUILD_ZOOM_CMD_PAUSE; ?>;
						//Disbale pause
						document.getElementById("pause").disabled =  true;
						//Enable start and stop
						document.getElementById("start").disabled = false;
						document.getElementById("stop").disabled = false;
						isPaused = true;
					}
					else if(buttonID == "stop")
					{
						zoomCmd = <?PHP echo $__CUSTOM_BUILD_ZOOM_CMD_STOP; ?>;
						//Disbale stop and pause
						document.getElementById("pause").disabled =  true;
						document.getElementById("stop").disabled = true;
						//Enable start
						document.getElementById("start").disabled = false;
					}
					SendHttpRequest("send_zoom_command.php?command="+zoomCmd);
				}
				
				function pageTimeout()
				{
					//Using set timeout so we can reset it after the XMLHttpRequest request has finished
					//So we don't get multipler equests at the same time
				 //setInterval("showStatus()", 1000); //Setinterval, executes over and over at specififed interval
				 	setTimeout("showStatus()", 1000);  //Settimeout, executes once after spoecified interval
				 		setTimeout("showLog()", 2000); //Start log timeout
				 // pageTimeout(); //call this function 
				}
			
			function getNodeValue(parent, tagName) 
			{ 
				var node = parent.getElementsByTagName(tagName)[0]; 
				return (node && node.firstChild) ? node.firstChild.nodeValue : false; 
			}
			
			function showStatus()
				{				
				 var xmlhttp;
				
				 if(window.XMLHttpRequest)
				 {
				  //IE7_, FireFox, Chrome, OPera, Safari
				  xmlhttp = new XMLHttpRequest();
				 }
				 else
				 {
				  //IE 6, 5
				  xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
				 }
				
				 xmlhttp.onreadystatechange = function()
				 {
				  if(xmlhttp.readyState==4 && xmlhttp.status==200)
				  {

				  	var response = xmlhttp.responseXML.documentElement;
				    var statusvalues = response.getElementsByTagName('statusvalue');
				    				    	
				    	  			
				    for(var i=0; i < statusvalues.length; i++)
				    {
				    		 var target = getNodeValue(statusvalues[i], 'target'); 
				    		 var value = getNodeValue(statusvalues[i], 'value');
				    		
				    		 if(target && value) 
				    		 {
				    		 	var currentElement = 	document.getElementById(target);
				    		 	if(currentElement)
				    		 		currentElement.innerHTML = value;				    			
				    		}
				    }
 
				   		
						  //Need to enable/disable buttons depending on status 
						  var curStatus = document.getElementById("IndexerStatus").innerHTML;

							
						  switch(curStatus)
							{
								//Indexing has finished / stopped
								case "":
								case "N/A":
								case "Partial index complete (stopped by user)":
								case "Indexing completed":
								case "Out of memory":
								//Disable stop and pause
								document.getElementById("pause").disabled =  true;
								document.getElementById("stop").disabled = true;
								//Enable start
								document.getElementById("start").disabled = false;
								break;
								
								//Index is paused
								case "Paused":

								//Disable pause 
								document.getElementById("pause").disabled =  true;
								//Enable start
								document.getElementById("start").disabled = false;
								document.getElementById("stop").disabled = false;
								//Reset timeout for next update
				   			setTimeout("showStatus()", 1000);
								break;
								
								//Waiting to quit
								case "Waiting to quit":
								<?PHP
								echo "var ZOOM_CMD_QUIT = $__CUSTOM_BUILD_ZOOM_CMD_QUIT;";	
								?>
								//Need to send a quit message
								SendHttpRequest("send_zoom_command.php?command="+ZOOM_CMD_QUIT);
									
								//Disable stop and pause
								document.getElementById("pause").disabled =  true;
								document.getElementById("stop").disabled = true;
								//Enable start
								document.getElementById("start").disabled = false;
								
								//Set status to finished
								document.getElementById("IndexerStatus").innerHTML = "Finished";
								break;
								
							default:
							//Reset timeout for next update
				   		 setTimeout("showStatus()", 1000);
								break;
															
							}
				   
				  }

				 }
				 
				 xmlhttp.open("GET", "get_zoom_status.php", true);
				 xmlhttp.send();
				 
				}
				
				
				function showLog()
				{				
				 var xmlhttp;
				
				 if(window.XMLHttpRequest)
				 {
				  //IE7_, FireFox, Chrome, OPera, Safari
				  xmlhttp = new XMLHttpRequest();
				 }
				 else
				 {
				  //IE 6, 5
				  xmlhttp = new ActiveXObject("Microsoft.XMLHTTP");
				 }
				
				 xmlhttp.onreadystatechange = function()
				 {
				  if(xmlhttp.readyState==4 && xmlhttp.status==200)
				  {

				  	var response = xmlhttp.responseXML.documentElement;
				    var loglines = response.getElementsByTagName('logline');
    	
    				var LogDiv = 	document.getElementById("log_output");    	
				    var logStr = "";
				    		
				    for(var i=0; i < loglines.length; i++)
				    {
				    	
				    		 var type = getNodeValue(loglines[i], 'type'); 
				    		 var timestr = getNodeValue(loglines[i], 'time');
				    		 var value = getNodeValue(loglines[i], 'value');
				    		
				    		 //var currentElement = 	document.getElementById(target);
				    		 //if(currentElement)
				    		 //	currentElement.innerHTML = value;			
				    		 
								logStr += timestr + " " + value + "<br>";
				    		 
				    }
					  if(loglines.length > 0)
						   LogDiv.innerHTML = logStr;
						    
						 //Need to estop if indexer has finished
						 var curStatus = document.getElementById("IndexerStatus").innerHTML;
								
						  switch(curStatus)
							{
								//Indexing has finished / stopped
								case "":
								case "N/A":
								case "Partial index complete (stopped by user)":
								case "Indexing completed":
								case "Out of memory":
								break;
								
							default:
							//Reset timeout for next update
					  		 setTimeout("showLog()", 2000);
								break;
															
							}
					}
				   
				  }

				 xmlhttp.open("GET", "get_zoom_log.php", true);
				 xmlhttp.send();
				 
				}
				
			</script>
	</head>
	
	<div id=main_content>
	
	<div id="config">
	<form action="config.php" method="post" >
	<table>
	<!-- If we use a file input field can't set a default, can't copy/paste -->
	<?php
	echo "<tr><td>Zoom config file: <input type=\"text\" size=35 id=\"config_filename\" name=\"config_filename\" value=\"$CurrentConfig\"></td></tr>";
	?>
	
	<tr><td><input type="submit" value="Configure" name="submit" ></td></tr>
	</table>
	</form>
	</div>
	
		<!-- Start/Stop/Pause bttons -->	
	<div id="controls">
		<button id="start" onClick="sendCommand(this.id);">Start</button>
		<button id="pause" disabled onClick="sendCommand(this.id);">Pause</button>
		<button id="stop" disabled onClick="sendCommand(this.id);">Stop</button>
	</div>		
	
	
	<!-- Status information -->	
	<div id="status">
			<table>
					<tr>
						<td class="status_col">Status</td>
						<td class="counter_col">Counter</td>
					</tr>
					<tr>
						<td >Files indexed</td>
						<td id="FilesIndexed">&nbsp;</td>
					</tr>
					<tr >
						<td >Files skipped</td>
								<td id="NumSkipped">&nbsp;</td>
					</tr>
					<tr >
						<td >Files filtered</td>
								<td id="NumFiltered">&nbsp;</td>
					</tr>		
					<tr >
						<td >Files downloaded</td>
								<td id="NumDownloaded">&nbsp;</td>
					</tr>			
					<tr >
						<td >Unique words found</td>
					<td id="NumUniqueWords">&nbsp;</td>
					</tr>			
						<tr >
						<td >Variant words found</td>
						<td id="NumVariants">&nbsp;</td>
						
					</tr>			
					<tr >
						<td >Total words found</td>
						<td id="NumTotalWords">&nbsp;</td>
					</tr>		
					<tr >
						<td >Avg. unique words per page</td>
						<td id="AvgUniqueWordsPerPage">&nbsp;</td>
					</tr>
					<tr >
						<td >Avg. words per page</td>
						<td id="AvgWordsPerPage">&nbsp;</td>
					</tr>
					<tr >
						<td >Start index time</td>
						<td id="StartTime">&nbsp;</td>
					</tr>
					<tr >
						<td >Elapsed index time</td>
						<td id="ElapsedTime">&nbsp;</td>
					</tr>
					<tr >
						<td >URLs visited by spider</td>
							<td id="VisitedURLs">&nbsp;</td>
					</tr>
						<tr >
						<td >URLs in spider queue</td>
						<td id="QueuedURLs">&nbsp;</td>
					</tr>
					<tr >
						<td >Start points scanned</td>
						<td id="StartPtTotal">&nbsp;</td>
					</tr>
					<tr >
						<td >Total bytes scanned/downloaded (MB)</td> 
						<td id="TotalBytes">&nbsp;</td>
					</tr>
			</table>
	</div> <!-- status -->
	
			
	
	<!-- Errors and warnings -->	
	<div id="errors_div">
		<table class="error_table">
				<tr class=table_name>
					<td colspan=2>Errors and Warnings</td>
				</tr>
					<tr >
						<td class="err_status_col">Status</td>
						<td class="err_counter_col">Counter</td>
						<td class="err_show_col">Show</td>
					</tr>
					<tr>
						<td>Errors</td>
						<td id="Errors">&nbsp;</td>
					</tr>
					<tr >
						<td>Warnings</td>
						<td id="Warnings">&nbsp;</td>
					</tr>
					<tr>
						<td >Broken Links</td>
						<td id="BrokenLinks">&nbsp;</td>
					</tr>				
			</table>
	</div> <!-- errors -->

	<!-- Thread status and information -->	
	<fieldset>
	<legend>Thread Status</legend>	
	<div id=thread_status>
				<table class=thread_table>
					<tr class=thread_table>
						<td class="table_header">Thread #</td>
						<td class="table_header">Status</td>
						<td class="table_header">Progress</td>
						<td class="table_header">URL</td>
					</tr>
					<tr class=thread_table>
						<td class="thread_id_col"> Indexer</td>
						<td class="thread_status_col" id="IndexerStatus"></td>
						<td class="thread_prog_col"></td>
						<td class="thread_url_col" id="CurrentFilePath"></td>
					</tr>
					<tr class=thread_table>
						<td class="thread_id_col">DL #1</td>
						<td class="thread_status_col" id="THREAD1_Status"></td>
						<td class="thread_prog_col" id="THREAD1_Progress"></td>
						<td class="thread_url_col" id="THREAD1_CurrentFilePath"></td>
					</tr>
					<tr class=thread_table>
						<td class="thread_id_col">DL #2</td>
						<td class="thread_status_col" id="THREAD2_Status"></td>
						<td class="thread_prog_col" id="THREAD2_Progress"></td>
						<td class="thread_url_col" id="THREAD2_CurrentFilePath"></td>
					</tr>
					<tr class=thread_table>
						<td class="thread_id_col">DL #3</td>
						<td class="thread_status_col" id="THREAD3_Status"></td>
						<td class="thread_prog_col" id="THREAD3_Progress"></td>
						<td class="thread_url_col" id="THREAD3_CurrentFilePath"></td>
					</tr>
					<tr class=thread_table>
						<td class="thread_id_col">DL #4</td>
						<td class="thread_status_col" id="THREAD4_Status"></td>
						<td class="thread_prog_col" id="THREAD4_Progress"></td>
						<td class="thread_url_col" id="THREAD4_CurrentFilePath"></td>
					</tr>
					<tr class=thread_table>
						<td class="thread_id_col">DL #5</td>
						<td class="thread_status_col" id="THREAD5_Status"></td>
						<td class="thread_prog_col" id="THREAD5_Progress"></td>
						<td class="thread_url_col" id="THREAD5_CurrentFilePath"></td>
					</tr>
					<tr class=thread_table>
						<td class="thread_id_col">DL #6</td>
						<td class="thread_status_col" id="THREAD6_Status"></td>
						<td class="thread_prog_col" id="THREAD6_Progress"></td>
						<td class="thread_url_col" id="THREAD6_CurrentFilePath"></td>
					</tr>
					<tr class=thread_table>
						<td class="thread_id_col">DL #7</td>
						<td class="thread_status_col" id="THREAD7_Status"></td>
						<td class="thread_prog_col" id="THREAD7_Progress"></td>
						<td class="thread_url_col" id="THREAD7_CurrentFilePath"></td>
					</tr>
					<tr class=thread_table>
						<td class="thread_id_col">DL #8</td>
						<td class="thread_status_col" id="THREAD8_Status"></td>
						<td class="thread_prog_col" id="THREAD8_Progress"></td>
						<td class="thread_url_col" id="THREAD8_CurrentFilePath"></td>
					</tr>
					<tr class=thread_table>
						<td class="thread_id_col">DL #9</td>
						<td class="thread_status_col" id="THREAD9_Status"></td>
						<td class="thread_prog_col" id="THREAD9_Progress"></td>
						<td class="thread_url_col" id="THREAD9_CurrentFilePath"></td>
					</tr>
					<tr class=thread_table>
						<td class="thread_id_col">DL #10</td>
						<td class="thread_status_col" id="THREAD10_Status"></td>
						<td class="thread_prog_col" id="THREAD10_Progress"></td>
						<td class="thread_url_col" id="THREAD10_CurrentFilePath"></td>
					</tr>
			</table>
	</div> <!-- thread_status -->
</fieldset>
	<fieldset>
	<legend>Log Snapshot</legend>	
	<div id=log_output>
	</div><!-- log_output -->
	</fieldset>
</div> <!-- main_content -->
</html>
