<?PHP
//Turn off warnings otherwise response will not be properly formed if shmop_open fails (eg indexer has finished and closed shared memory block)
error_reporting(E_ERROR);
require("zoom_defines.php");


$shm_id = shmop_open($MappedLogBufferKey, "w", 0, 0);

//If we failed to open the mapped memory block return
if($shm_id == false)
{
	header('Content-Type: text/xml');     
	echo '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>' . "\n";
	echo "<response> </response>\n";
	exit;
}


$shm_size = shmop_size($shm_id);

	  
function AddLogLine($type, $time, $value)
{
	//Convert time so we don't need to use javascript
	echo "<logline><type>" . $type . "</type><time>" . date("Y-m-d H:i:s", $time)  . "</time><value>". htmlentities($value) . "</value></logline>\n";	
}
	   
$shm_contents = shmop_read($shm_id, 0, $shm_size);


//Close
shmop_close($shm_id);


$LogHeaderSize = 16;

$numLines = 0;
$bytesRead = 0;

header('Content-Type: text/xml');     
echo '<?xml version="1.0" encoding="UTF-8" standalone="yes"?>' . "\n";
echo "<response>";


while($numLines < 25)
{

	//Need to modify each unpack statement per line
	$unpack_struct_str = 
	 'x'.$bytesRead .'/'.
	  'iBufferLen/'.
	 'iType/'.
	 'iTime/'.
	 'iProgress/';

	
	//Need to unpack based on byte counts in header, first get next header
	$nextHeader = unpack($unpack_struct_str, $shm_contents); //+$bytesRead
	
	if($nextHeader["BufferLen"] == 0)
		break;
	
	$bytesRead += $LogHeaderSize;
	
	//Unpack actual log line now we have header
	$unpack_struct_str = 
	 'x'.$bytesRead .'/'.
	 'a'.$nextHeader["BufferLen"] .'Line/';
	
	$LogLine = unpack($unpack_struct_str, $shm_contents); //+$bytesRead
	
	//Format into an XML reponse
	//Currently save each log line as 
	//<logline><type>...</type><time>...</time><value>...</value</logline>
	
	$bytesRead += $nextHeader["BufferLen"];
	
	AddLogLine($nextHeader["Type"], $nextHeader["Time"], $LogLine["Line"]);
	
	$numLines++;
}

	
	echo "</response>\n";
	//End response


?>


